<template>
  <div class="modal-container" id="optConfirmModal">
    <div class="modal-header">
      <p class="title">{{ $t('otp.removeOtp.title') }}</p>
      <button type="button" @click="closeModal()" class="btn-close"><span aria-hidden="true">×</span></button>
    </div>
    <div class="modal-body">
      <div class="form-group">
        <input name="password"
          v-validate="'required'"
          @keyup.enter="verifyCode"
          type="password"
          @focus="resetError"
          v-model="password"
          data-vv-validate-on="none"
          :placeholder="$t('otp.removeOtp.placeholder.password')"
        >
        <span class="invalid-feedback" v-if="errors.has('password')">
          {{ errors.first('password') }}
        </span>
      </div>
      <div class="form-group">
        <input name="code"
          v-validate="'required|length:6'"
          @keyup.enter="verifyCode"
          data-vv-as="OTP code"
          type="text"
          @focus="resetError"
          maxlength="6"
          @keypress="isNumber"
          v-model="code"
          data-vv-validate-on="none"
          :placeholder="$t('otp.removeOtp.placeholder.code')"
        >
        <span class="invalid-feedback" v-if="errors.has('code')">
          {{ errors.first('code') }}
        </span>
      </div>
      <div class="text-center">
        <button type="button" class="btn btn-submit" @click="verifyCode">{{ $t('otp.btnSubmit') }}</button>
      </div>
    </div>
  </div>
</template>
<script>
import { mapMutations } from 'vuex';

import OtpInputMixin from './OtpInputMixin';
import rf from '../../requests/RequestFactory';

export default {
  data () {
    return {
      code: '',
      password: '',
    };
  },
  mixins: [OtpInputMixin],
  methods: {
    ...mapMutations([
      'updateUser',
    ]),
    closeModal () {
      this.$broadcast('close-modal');
    },
    verifyCode () {
      this.$validator.validateAll()
        .then(() => {
          if (this.errors.any()) {
            return;
          }
          const params = {
            code: this.code,
            password: this.password,
          };
          rf.getRequest('UserRequest').removeAuthentication(params)
            .then(res => {
              this.updateUser(res.data);
              this.$toasted.show(this.$t('otp.removeOtp.message.success'), {
                theme: 'bubble',
                position: 'top-right',
                duration : 2000,
              });
              this.closeModal();
            })
            .catch((error) => {
              this.errors.clear();
              const errors = error.errors;
              Object.keys(errors).forEach((key) => {
                this.errors.add({
                  field: key,
                  msg: errors[key][0]
                });
              });
            });
        })
    },
  },
};
</script>
<style lang="scss" scoped>
  @import '../../../../sass/app.scss';

  #optConfirmModal {
    width: 450px;
    height: 320px;
    border-radius: 10px;
    background-color: #f7f7f7;
    margin: auto;
    box-shadow: 0 2px 40px 0 rgba(0, 0, 0, 0.18);
    .modal-header {
      padding: 0;
      border: none;
      position: relative;
      .title {
        font-size: 18px;
        font-weight: bold;
        color: #1c1c1c;
        text-align: center;
        margin: 55px auto 5px;
      }
      .btn-close {
        width: 30px;
        height: 30px;
        background-color: $bg_white;
        border: 1px solid $white;
        border-radius: 50%;
        position: absolute;
        outline: none;
        top: 15px;
        right: 15px;
        span {
          cursor: pointer;
          color: $thin_gray;
          font-size: 17px;
        }
      }
    }
    .modal-body {
      margin: 0;
      padding: 0;
      .form-group {
        text-align: center;
        background: none;
        margin: 20px auto 0;
        position: relative;
        padding: 0;
        width: 330px;
        input {
          width: 100%;
          height: 40px;
          border-radius: 74px;
          background-color: $bg_white;
          border: 1px solid $white;
          font-size: 14px;
          padding: 0 15px;
          &:placeholder {
            color: #cacaca;
          }
        }
      }
      .btn-submit {
        margin-top: 30px;
        width: 90px;
        height: 32px;
        border-radius: 30px;
        border: solid 1px $dark_orange;
        font-size: 14px;
        font-weight: bold;
        font-style: normal;
        font-stretch: normal;
        line-height: normal;
        letter-spacing: 0.5px;
        color: white;
        outline: none;
        background: $orange;
        &:hover {
          background: $dark_orange;
          color: white;
        }
      }
    }
    .invalid-feedback {
      color: red;
      position: absolute;
      text-align: left;
      bottom: -20px;
      font-size: 13px;
      left: 15px;
    }
  }
</style>
